﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Windows.Input;
using System.Windows;

namespace Niche.BindingLagDemo
{
    public class SampleModel : INotifyPropertyChanged
    {
        public string Caption
        {
            get { return mCaption; }
            set
            {
                if (mCaption != value)
                {
                    mCaption = value;
                    OnPropertyChanged("Caption");
                }
            }
        }

        public ICommand ShowCommand
        {
            get { return mShowCommand; }
        }

        public SampleModel()
        {
            mShowCommand = new SimpleDelegateCommand(Show);
        }

        public void Show(object parameter)
        {
            MessageBox.Show(Caption, "DataBinding Lag Demo", MessageBoxButton.OK);
        }

        public event PropertyChangedEventHandler PropertyChanged
        {
            add { mPropertyChanged += value; }
            remove { mPropertyChanged -= value; }
        }

        private void OnPropertyChanged(string propertyName)
        {
            var handlers = mPropertyChanged;
            if (handlers != null)
            {
                var args = new PropertyChangedEventArgs(propertyName);
                handlers(this, args);
            }
        }

        private string mCaption;

        private PropertyChangedEventHandler mPropertyChanged;
        private SimpleDelegateCommand mShowCommand;
    }
}
